"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ConfigUpdater = void 0;

var _logger = require("./logger");

const trueValues = ['y', 'Y', 'yes', 'Yes', 'YES', 'true', 'True', 'TRUE', '1', true];

class ConfigUpdater {
  static updateConfig(newConfig, configObject) {
    newConfig.forEach(function (v, k) {
      switch (k) {
        case "NODE_StringCache_UserMessage":
          _logger.logger.debug("Updating STRING_CACHE_USERMESSAGE value to: " + (trueValues.indexOf(v) !== -1));

          configObject.DumpConfig.STRING_CACHE_USERMESSAGE = trueValues.indexOf(v) !== -1;
          break;

        case "NODE_PROTOBUF_VERSION_2":
          let protobuf2EnvVar = process.env.PROTOBUF_VERSION_2;

          if (protobuf2EnvVar) {
            _logger.logger.debug("Updating Protobuf_Version2 from env var value to: " + (trueValues.indexOf(protobuf2EnvVar) !== -1));

            configObject.OutputWsConfiguration.PROTOBUF_VERSION2 = trueValues.indexOf(protobuf2EnvVar) !== -1;
          } else {
            _logger.logger.debug("Updating Protobuf_Version2 value to: " + (trueValues.indexOf(v) !== -1));

            configObject.OutputWsConfiguration.PROTOBUF_VERSION2 = trueValues.indexOf(v) !== -1;
          }

      }
    });
  }

}

exports.ConfigUpdater = ConfigUpdater;
//# sourceMappingURL=configUpdater.js.map